Subject: Re: [PATCH 2/2] powerpc - Make the irq reverse mapping radix tree lockless

From: Sebastien Dugue <[email-masked]>
Date: Thu, 4 Sep 2008 09:22:52 +0200

On Thu, 04 Sep 2008 12:52:19 +1000 Benjamin Herrenschmidt <[email-masked]> wrote:

> On Wed, 2008-09-03 at 15:41 +0200, Sebastien Dugue wrote:
> > On Wed, 20 Aug 2008 15:23:01 +1000 Benjamin Herrenschmidt <[email-masked]> wrote:
> > 
> > > BTW. It would be good to try to turn the GFP_ATOMIC into GFP_KERNEL,
> > 
> >   That would be nice indeed
> > 
> > > maybe using a semaphore instead of a lock to protect insertion vs.
> > > initialisation.
> > 
> >   a semaphore? are you meaning a mutex? If not, I fail to understand what you're
> > implying.
> 
> Right, a mutex, bad habit calling those semaphores from the old days :-)

  OK, then we're on the same line ;-)

> 
> >   Right, that's the problem with this new scheme and I'm still trying
> > to find a way to handle memory allocation failures be it for GFP_ATOMIC or
> > GFP_KERNEL.
> > 
> >   I could not think of anything simple so far and I'm open for suggestions.
> 
> GFP_KERNEL should not fail, it will just block no ?

  No it won't block and will fail (returns NULL).

> If it fails, it's
> probably catastrophic enough not to care.

  Yep, I'd tend to agree with that.

> You can always fallback to linear lookup.

  I will have to add that back as there is no more fallback.

> I don't know if it's worth trying to fire off a new
> allocation attempt later, probably not.

  I've been pondering with this lately, but I think that adding a linear
lookup fallback should be OK.

  Thanks,

  Sebastien.

> 
> Ben.
> 
> 
> _______________________________________________
> Linuxppc-dev mailing list
> [email-masked]
> https://ozlabs.org/mailman/listinfo/linuxppc-dev
>